<?

header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");
header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT"); 
header("Cache-Control: no-store, no-cache, must-revalidate"); 
header("Cache-Control: post-check=0, pre-check=0", false);
header("Pragma: no-cache");

session_set_cookie_params(365*24*60*60);
if(!session_start()){
	die("session_start() failed. That's a server error. Please contact the maintainer");
}

require("mysql.php");
require("oauth_lib.php");

/* Check session vars */
if(!isset($_SESSION["mapillary_access_token"]) || !isset($_SESSION["osm_oauth_token_secret"]) || !isset($_SESSION["openstreetcam_token"])){
	echo "Error: Session expired or authentications aren't finished";
	die();
}

/* Read DB profile */
$ekey = mysql_real_escape_string($_SESSION["mapillary_key"]);
$qr = mysql_query("select * from mp2osc_auth where mapillary_userid='{$ekey}'") or die(mysql_error());
if(!($profile = mysql_fetch_object($qr))){
	die("Can't read DB profile");
}

if(isset($_GET["sequences"])){
	/* Read cached Mapillary sequences */
	$mapillary_sequences = array();
	$sqr = mysql_query("select * from mapillary_sequence where user_key='".mysql_real_escape_string($_SESSION["mapillary_key"])."' order by captured_at desc") or die(mysql_error()); // created_at > DATE_SUB(NOW(), INTERVAL 12 MONTH)
	while($sq = mysql_fetch_object($sqr)){
		if($sq->images < 2){
			continue;
		}
		$sq->captured_at_ts = strtotime($sq->captured_at);
		$mapillary_sequences[]=$sq;
	}
	/* Read cached OpenStreetCam sequences */
	$osc_sequences = array();
	$sqr = mysql_query("select * from openstreetcam_sequence where user_id='".mysql_real_escape_string($profile->openstreetcam_userid)."' order by date_added desc") or die(mysql_error());
	while($sq = mysql_fetch_object($sqr)){
		$sq->date_added_ts = strtotime($sq->date_added);
		$osc_sequences[]=$sq;
	}
	/* Return */
	$ret = array(
		"mapillary" => $mapillary_sequences,
		"osc" => $osc_sequences,
		"mapillary_sequence_updated" => $profile->mapillary_sequence_updated,
		"osc_sequence_updated" => $profile->openstreetcam_sequence_updated,
	);
	$cs = hash("crc32b", serialize($ret));
	if($cs === $_GET["cs"]){
		die("NC");
	}
	$ret["cs"] = $cs;
	echo json_encode($ret);
	die();
}else if(isset($_GET["status"])){
	for($i=0; $i<4; $i++){
		$ret = array("jobs"=>array());
		$qr = mysql_query("select task_id,task,subject,added,started,updated,finished,success,progress from mp2osc_jobs where mapillary_userid='{$ekey}' and (task='mp2osc' or task='osc2mp' or UNIX_TIMESTAMP()-added < 30*60) order by added desc") or die(mysql_error());
		while($q = mysql_fetch_object($qr)){
			$q->added = intval($q->added);
			$q->started = intval($q->started);
			$q->updated = intval($q->updated);
			$q->finished = intval($q->finished);
			$q->success = intval($q->success);
			$ret["jobs"][]=$q;
		}
		$cs = hash("crc32b", serialize($ret));
		if($cs !== $_GET["cs"]){
			break;
		}
		usleep(250000);
	}
	if($cs === $_GET["cs"]){
		die("NC");
	}
	$ret["cs"] = $cs;
	echo json_encode($ret);
	die();
}else if(isset($_POST["read_mapillary"]) || isset($_POST["read_osc"])){
	$task = isset($_POST["read_mapillary"]) ? "read_mapillary" : "read_osc";
	// check if the job is already running
	$qr = mysql_query("select * from mp2osc_jobs where mapillary_userid='{$ekey}' and task='{$task}' order by added desc limit 1") or die(mysql_error());
	if($q = mysql_fetch_object($qr)){
		if(time() - $q->added < 60 && $q->started == 0){
			// give it a minute to start
			// before allowing the second attempt
			die("E:STARTING");
		}else if(time() - $q->updated < 5*60 && $q->finished == 0){
			// wait 5 minutes
			// before considering the proccess dead
			die("E:WORKING");
		}else if(time() - $q->finished < 5*60){
			// finished less than 5 minutes ago
			// do not allow to restart too frequently
			die(($q->success > 0) ? "E:FINISHED" : "E:FAILED");
		}
	}
	// add new job
	$task_id = uuid();
	$esubject = mysql_real_escape_string(isset($_POST["read_mapillary"]) ? $profile->mapillary_userid : $profile->osm_username);
	mysql_query("insert into mp2osc_jobs set task_id='{$task_id}', subject='{$esubject}', mapillary_userid='{$ekey}', task='{$task}', added=UNIX_TIMESTAMP()") or die(mysql_error());
	// run the worker
	if(isset($_POST["read_mapillary"])){
		$log_fn = "log/read_mapillary_{$task_id}.log";
		shell_exec("nohup php -f read_mapillary.php ".escapeshellarg($task_id)." ".escapeshellarg($profile->mapillary_client_id)." ".escapeshellarg($profile->mapillary_access_token)." ".escapeshellarg($profile->mapillary_userid)." > {$log_fn} &");
		die("K");
	}else if(isset($_POST["read_osc"])){
		$log_fn = "log/read_osc_{$task_id}.log";
		$user = (!empty($profile->openstreetcam_username)) ? $profile->openstreetcam_username : strtolower(str_replace(" ", "-", $profile->osm_username));
		shell_exec("nohup php -f read_osc.php ".escapeshellarg($task_id)." ".escapeshellarg($profile->openstreetcam_token)." ".escapeshellarg($user)." > {$log_fn} &");
		die("K");
	}
}else if(isset($_POST["mp2osc"])){
	$task = "mp2osc";
	$sequences = preg_replace("/[^0-9a-zA-Z,_-]/", "", $_POST["mp2osc"]);
	$sequences = explode(",", $sequences);
	$cnt = count($sequences);
	$started = 0;
	foreach($sequences as $sequence_id){
		$esubject = mysql_real_escape_string($sequence_id);
		// check if the sequence was already transfered
		$qr = mysql_query("select * from mapillary_sequence where sequence_key='{$esubject}' limit 1") or die(mysql_error());
		if($q = mysql_fetch_object($qr)){
			if($q->images_transferred > 0){
				// already transferred (fully or partially)
				if($cnt > 1){
					continue;
				}else{
					die("E:TRANSFERRED");
				}
			}
		}else{
			// can't find sequence
			if($cnt > 1){
				continue;
			}else{
				die("E:NOTFOUND");
			}
		}
		// block 1-image sequences
		if($q->images < 2){
			if($cnt > 1){
				continue;
			}else{
				die("Please select sequences with at least two images");
			}
		}
		// block 360 images
		/*if($q->pano == 1){
			if($cnt > 1){
				continue;
			}else{
				die("360 images are not supported yet (stay tuned!)");
			}
		}*/
		// check if the job is already running or queued
		$qr = mysql_query("select * from mp2osc_jobs where mapillary_userid='{$ekey}' and task='{$task}' and subject='{$esubject}' order by added desc limit 1") or die(mysql_error());
		if($q = mysql_fetch_object($qr)){
			if($q->started == 0){
				if($cnt > 1){
					continue;
				}else{
					die("E:QUEUED");
				}
			}else if(time() - $q->updated < 5*60 && $q->finished == 0){
				// wait 5 minutes
				// before considering the proccess dead
				if($cnt > 1){
					continue;
				}else{
					die("E:WORKING");
				}
			}else if(time() - $q->finished < 5*60){
				// finished less than 5 minutes ago
				// do not allow to restart too frequently
				if($cnt > 1){
					continue;
				}else{
					die(($q->success > 0) ? "E:FINISHED" : "E:FAILED");
				}
			}else{
				if($cnt > 1){
					continue;
				}else{
					die("E:EXISTS");
				}
			}
		}
		// add new job
		$task_id = uuid();
		mysql_query("insert into mp2osc_jobs set task_id='{$task_id}', subject='{$esubject}', mapillary_userid='{$ekey}', task='{$task}', added=UNIX_TIMESTAMP()") or die(mysql_error());
		// run the worker
		$started++;
	}
	if($started < $cnt){
		die("{$started} of {$cnt} jobs were added. Call individual rows to see details why they can't be added");
	}
	die("K");
}else if(isset($_POST["cancel"])){
	$task_id = mysql_real_escape_string($_POST["cancel"]);
	mysql_query("delete from mp2osc_jobs where task_id='{$task_id}' and mapillary_userid='{$ekey}'") or die(mysql_error());
	if(mysql_affected_rows() > 0){
		die("K");
	}else{
		die("Couldn't cancel");
	}
}else{
	die("Unknown request type");
}

?>