<?

require("mysql.php");

$days = isset($_GET["days"]) ? min(1000, max(1, intval($_GET["days"]))) : 365;
$interval = isset($_GET["interval"]) ? min(365, max(0.04, floatval($_GET["interval"]))) : 1;
$step = 3;
$w = $days*$step/$interval;
$h = 400;
$padding_left = 40;
$padding_right = 100;
$header = 20;
$footer = 68;

$stats = array();
$platforms = array();
$qs = "select UNIX_TIMESTAMP(date_added) as ts,images,platform_name from openstreetcam_sequence where date_added > DATE_SUB(NOW(), INTERVAL {$days} DAY) order by date_added desc";
$qr = mysql_query($qs) or die(mysql_error());
$t = time();
while($q = mysql_fetch_object($qr)){
	$platform = $q->platform_name;
	if($platform == ""){
		$platform = "unknown";
	}else if(substr($platform, 0, 6) === "iPhone"){
		$platform = "iPhone";
	}else if(substr($platform, 0, 4) === "iPad"){
		$platform = "iPad";
	}else if(substr($platform, 0, 7) === "Android"){
		$platform = "Android";
	}else if(substr($platform, 0, 7) === "samsung"){
		$platform = "samsung";
	}
	$ago = $t - $q->ts;
	$k = intval(floor($ago/60/60/24/$interval));
	if(!isset($stats[$k])){
		$stats[$k] = array();
	}
	if(!isset($stats[$k][$platform])){
		$stats[$k][$platform] = 0;
	}
	$stats[$k][$platform]+=$q->images;

	$platforms[$platform] = $k;
}

// Array ( [photosync] => 3 [Android] => 103 [Waylens] => 103 [iOS] => 88 [unknown] => 103 [iPhone] => 103 [GoPro] => 63 [samsung] => 90 [iPad] => 97 ) 
// print_r($platforms);die();

$max = 0;
for($k = 0; $k<=$start; $k++){
	$sum = 0;
	foreach($platforms as $platform => $start){
		$sum+=$stats[$k][$platform];
	}
	$max = max($max, $sum);
}
$scale = $max / $h;

$im = imagecreatetruecolor($w + $padding_left + $padding_right, $h + $header + $footer);
imagefilledrectangle($im, 0, 0, $w + $padding_left + $padding_right, $h + $header + $footer, 0xFFFFFF);
$font = "verdana.ttf";

imagettftext($im, 8, 0, $padding_left, 10, 0x000000, $font, "Images uploaded per day");

for($i=0; $i<$h; $i+=20){
	$y = $h + $header - $i;
	imageline($im, $padding_left, $y, $w + $padding_left, $y, 0xEEEEEE);
	imagettftext($im, 8, 0, 0, $y+3, 0x000000, $font, str_pad(intval(round($i * $scale / 1000))."k", 6, " ", STR_PAD_LEFT));
}

for($k=0; $k<=max($platforms); $k++){
	$x = $w - ($k * $step) - 1 + $padding_left;
	if($k % 7 == 0){
		imageline($im, $x, $header, $x, $h + $header, 0xEEEEEE);
	}
	if($k % 30 == 0){
		imagettftext($im, 8, 90, $x+5, $h + $header + $footer, 0x000000, $font, date("Y-m-d", $t - ($k*60*60*24*$interval)));
	}
}

$offset = array();
for($k=0; $k<=max($platforms); $k++){
	$offset[$k] = 0;
}

$legend_n = count($platforms)-1;
foreach($platforms as $platform => $start){
	$r=$g=$b=255;
	while($r+$b+$g > 500){
		$r=rand(0,255);
		$g=rand(0,255);
		$b=rand(0,255);
	}
	$color = imagecolorallocate($im, $r, $g, $b);

	imagettftext($im, 8, 0, $w + $padding_left + 5, $legend_n*20+8 + $header, $color, $font, $platform);
	$legend_n--;

	for($k=0; $k<=$start; $k++){
		if(!isset($stats[$k][$platform])){
			continue;
		}
		$x = $w - ($k * $step) - 1 + $padding_left;
		$y1 = $h + $header - round(($offset[$k]) / $scale);
		$y2 = $h + $header - round(($offset[$k] + $stats[$k][$platform]) / $scale);
		for($i=0; $i<$step; $i++){
			imageline($im, $x+$i, $y1, $x+$i, $y2, $color);
		}
		$offset[$k]+=$stats[$k][$platform];
	}
}

header("Content-type: image/png");
imagepng($im);

?>