<?

session_set_cookie_params(365*24*60*60);
if(!session_start()){
	die("session_start() failed. That's a server error. Please contact the maintainer");
}

if(isset($_GET["logout"])){
	$_SESSION = array();
	header("Location: /photosync/");
	die("Logged out");
}

?><html>
<head>
<title>Image transfer tool</title>
<style>
.login_block{
	width:200px;
	padding:10px 10px;
	margin-bottom:10px;
	margin-right:10px;
}
.brd{
	border:1px solid #000;
}
table.brd{
	border:none;
	border-collapse:collapse;
}
table.brd td{
	border:1px solid #000;
}
td,th{
	padding:2px 4px;
}
tr.status_queued td{
	background:#CCC;
}
tr.status_working td{
	background:#AFF;
}
tr.status_error td{
	background:#FAA;
}
tr.status_finished td{
	background:#AFA;
}
label.queued{
	color:#777;
}
label.working{
	color:#077;
}
label.error{
	color:#700;
}
label.finished{
	color:#070;
}
label.sync{
	color:#070;
}
.rbg{
	background:#FAA;
}
.g{
	color:#090;
}
.r{
	color:#C00;
}
.y{
	background:#FF7;
}
.brd h3{
	margin-top:5px
}
.avatar{
	margin-top:-10px;
	margin-bottom:5px;
}
hr{
	margin:10px 0 16px 0;
}
.sequence_list{
	height:296px;
	overflow-y:scroll;
	margin-bottom:5px;
}
.task_list{
	border-collapse:collapse;
}
.task_list td,.task_list th{
	vertical-align:middle;
	padding:2px 6px;
	border:1px solid #AAA;
}
.footer{
	margin:20px 0;
}
.fl{
	float:left;
}
.clr{
	clear:both;
}
</style>
<script src="lib.js?v=<?=filemtime("lib.js");?>"></script>
</head>
<body>

<?

require("mysql.php");
require("oauth_lib.php");

$ch = curl_init();

$auth_cnt = 0;

if(isset($_SESSION["mapillary_username"]) || isset($_SESSION["osm_display_name"])){
	echo "<div style=\"text-align:right;float:right;margin-right:2px\">";
	echo "<a href='?logout'>Log out</a><br>";
	echo "</div>";
	//print_r($_SESSION);
}

echo "<div class=\"login_block brd fl\">";
echo "<h3>Mapillary</h3>";
if(isset($_SESSION["mapillary_username"]) && read_mapillary_profile($ch, $_SESSION["mapillary_access_token"], $errstr) !== false){
	if(isset($_SESSION["mapillary_avatar"])){
		echo "<img src=\"".htmlspecialchars($_SESSION["mapillary_avatar"])."\" height=64 class=\"avatar\"><br>";
	}
	echo "Logged in as <b>".htmlspecialchars($_SESSION["mapillary_username"])."</b>";
	$auth_cnt++;
}else{
	/* Reset previous auth vars */
	unset($_SESSION["mapillary_username"]);
	unset($_SESSION["mapillary_access_token"]);

	/* Initialize new auth sequence */
	//$url = "{$settings['mapillary']['auth_url']}?client_id=OWlkdE******************************************MjU3&response_type=token&scope=".str_replace("+", "%20", urlencode($settings['mapillary']['permissions']))."&redirect_uri=".urlencode($settings['mapillary']['callback_url']);
	$url = "{$settings['mapillary']['auth_url']}?client_id=423*********3297";
	echo "<a href='{$url}'>Log in using OAuth</a><br>";
	echo "<a href='mapillary_auth.php'>Log in using password</a>";
}
echo "</div>";

echo "<div class=\"login_block fl\" style=\"width:13px;text-align:center\"><br>&#8644;</div>";

echo "<div class=\"login_block brd fl\">";
echo "<h3>OpenStreetCam</h3>";
if(isset($_SESSION["osm_display_name"]) && ($profile = read_osm_profile($ch, $_SESSION["osm_oauth_token"], $_SESSION["osm_oauth_token_secret"], $errstr)) !== false){
	if(isset($profile->user->img["href"])){
		echo "<img src=\"".htmlspecialchars($profile->user->img["href"])."\" height=64 class=\"avatar\"><br>";
	}
	if($_SESSION["openstreetcam"] == $_SESSION["osm_oauth_token"] && !empty($_SESSION["openstreetcam_token"])){
		echo "Logged in as <b>".htmlspecialchars($_SESSION["osm_display_name"])."</b>";
		//echo "OpenStreetCam authenticated";
		$auth_cnt++;
	}else{
		echo "<span class=r>OpenStreetCam auth failed</span>";
	}
}else{
	/* Reset previous auth vars */
	unset($_SESSION["osm_id"]);
	unset($_SESSION["osm_display_name"]);
	unset($_SESSION["osm_oauth_token"]);
	unset($_SESSION["osm_oauth_token_secret"]);
	unset($_SESSION["openstreetcam"]);
	unset($_SESSION["openstreetcam_token"]);

	/* Initialize new auth sequence */
	$ret = oauth_request_token($ch, "osm", $errstr);
	if($ret === false){
		die($errstr);
	}
	$_SESSION["osm_oauth_token"] = $ret["oauth_token"];
	$_SESSION["osm_oauth_token_secret"] = $ret["oauth_token_secret"];

	$url = "{$settings['osm']['auth_url']}?oauth_token={$ret['oauth_token']}";
	echo "<a href='{$url}'>Log in using OpenStreetMap</a>";
}
echo "</div>";

echo "<div class=\"clr\"></div><hr>";

if($auth_cnt !== 2){
	echo "Log in to both services first";
	die();
}

/* Multi-account check */
$qr = mysql_query("select * from mp2osc_auth where mapillary_userid='".mysql_real_escape_string($_SESSION["mapillary_key"])."'") or die(mysql_error());
if($q = mysql_fetch_object($qr)){
	if($q->osm_userid != $_SESSION["osm_id"]){
		echo "<h3>Error</h3>";
		echo "You were previously logged in with different OpenStreetCam account.<br>";
		echo "You can't transfer images from one Mapillary account to several OpenStreetCam accounts.<br>";
		echo "Please contact svimik@gmail.com if that's an error.<br>";
		die();
	}
}

/* Update tokens */
$set = array();
$set["mapillary_username"] = $_SESSION["mapillary_username"];
$set["mapillary_access_token"] = $_SESSION["mapillary_access_token"];
if(!empty($_SESSION["mapillary_client_id"])){
	$set["mapillary_client_id"] = $_SESSION["mapillary_client_id"];
}
$set["mapillary_email"] = $_SESSION["mapillary_email"];
$set["osm_userid"] = $_SESSION["osm_id"];
$set["osm_username"] = $_SESSION["osm_display_name"];
$set["osm_oauth_token"] = $_SESSION["osm_oauth_token"];
$set["osm_oauth_token_secret"] = $_SESSION["osm_oauth_token_secret"];
$set["openstreetcam_userid"] = $_SESSION["openstreetcam_userid"];
$set["openstreetcam_username"] = $_SESSION["openstreetcam_username"];
$set["openstreetcam_token"] = $_SESSION["openstreetcam_token"];
mysql_query("insert into mp2osc_auth set mapillary_userid='".mysql_real_escape_string($_SESSION["mapillary_key"])."',".mysql_array_to_set($set)." on duplicate key update ".mysql_array_to_set($set)) or die(mysql_error());

/* Read DB profile */
$qr = mysql_query("select * from mp2osc_auth where mapillary_userid='".mysql_real_escape_string($_SESSION["mapillary_key"])."'") or die(mysql_error());
if(!($q = mysql_fetch_object($qr))){
	die("Impossible error");
}

//echo "OpenStreetCam is acting slowly as of late. They probably didn't expect it. Don't worry, you can put all the sequences to transfer, close the tab, and come back to check the progress next time you remember about it :)<bb>";

echo "<table class=\"brd\" width=\"99%\" style=\"margin-top:15px\">";
echo "<tr>";
echo "<td width=\"50%\">";
	echo "<div class=sequence_list id=mapillary_sequence_list>Loading...</div>";
	echo "<button onclick=\"update_list('mapillary')\">Load Mapillary sequences</button> &nbsp;";
	echo "<button onclick=\"transfer('mp2osc')\" id=\"transfer_mapillary_btn\" disabled>Transfer selected sequences</button> &nbsp;";
	echo "<a href=\"javascript:select_new('mapillary');void(0)\">Select new sequences</a>";
echo "</td>";
echo "<td width=\"50%\">";
	echo "<div class=sequence_list id=osc_sequence_list>Loading...</div>";
	echo "<button onclick=\"update_list('osc')\">Load OpenStreetCam sequences</button> &nbsp;";
	//echo "<a href=\"javascript:select_new('osc');void(0)\">Select new sequences</a>";
echo "</td>";
echo "</tr>";
echo "</table>";

echo "<br>";
echo "<div id=\"job_list_div\"></div>";

if($q->mapillary_sequence_updated == 0 || $q->openstreetcam_sequence_updated == 0){
	echo "<br>";
	echo "How to use:<br>";
	echo "1. Log in with both Mapillary and OSC accounts<br>";
	echo "2. Press both <i>Load sequences</i> buttons to fetch the lists<br>";
	echo "3. Select sequences to transfer<br>";
	echo "4. Press the Transfer button. It will take a minute to start<br>";
	echo "5. The transfer will happen on the server side, you may close the tab<br>";
}

?>
<div class="footer">&copy; SviMik, 2020. For any questions please contact me via @gmail.com</div>
<script>page_loaded();</script>
</body>
</html>