<?

require("servers.php");
require("mysql.php");

// fix jobs that failed to start
$qr = mysql_query("select * from mp2osc_jobs where started>0 and started<UNIX_TIMESTAMP()-300 and updated=0 and success=0 and task='mp2osc'") or die(mysql_error());
while($q = mysql_fetch_object($qr)){
	// update task id
	$new_task_id = substr($q->task_id, 0, -4).str_pad(dechex(hexdec(substr($q->task_id, -4))+1), 4, "0", STR_PAD_LEFT);
	mysql_query("update mp2osc_jobs set server=0, started=0, task_id='".mysql_real_escape_string($new_task_id)."' where task_id='".mysql_real_escape_string($q->task_id)."' and task='mp2osc'") or die(mysql_error());
	echo "Task reset: {$new_task_id}\r\n";
}

// fix jobs that failed to create sequence
$qr = mysql_query("select * from mp2osc_jobs where finished>0 and success=0 and finished<UNIX_TIMESTAMP()-300 and task='mp2osc' and progress like '%Failed to create sequence%'") or die(mysql_error());
while($q = mysql_fetch_object($qr)){
	// update task id
	$new_task_id = substr($q->task_id, 0, -4).str_pad(dechex(hexdec(substr($q->task_id, -4))+1), 4, "0", STR_PAD_LEFT);
	mysql_query("update mp2osc_jobs set server=0, started=0, updated=0, finished=0, task_id='".mysql_real_escape_string($new_task_id)."' where task_id='".mysql_real_escape_string($q->task_id)."' and task='mp2osc'") or die(mysql_error());
	echo "Task reset: {$new_task_id}\r\n";
}

$backend_key = "******************";
$backend_uri = "/photosync/start.php";
$max_workers_per_server = 4; // hard limit
$max_workers_total = count($servers)*3; // soft limit
$max_workers_per_user = 8; // user limit

function start_job($q){
	global $backend_key, $curl, $jobs_running_server, $servers, $backend_uri, $max_workers_per_server;

	// $q->auth->mapillary_access_token
	// $q->subject
	// $q->auth->openstreetcam_token
	// $q->task_id
	//echo "{$q->auth->mapillary_access_token}\r\n{$q->subject}\r\n{$q->auth->openstreetcam_token}\r\n{$q->task_id}\r\n";
	//print_r($jobs_running_server);
	//print_r($servers);

	// find a server with minimum number of workers
	$min = $max_workers_per_server;
	$min_id = false;
	foreach($servers as $server_id => $ip){
		if($jobs_running_server[$server_id] < $min){
			$min = $jobs_running_server[$server_id];
			$min_id = $server_id;
		}
	}
	if($min_id === false){
		echo "All servers are occupied\r\n";
		die();
	}

	// see if this is a continuation
	$progress = false;
	if($q->progress != "" && substr($q->progress, 0, 1) == '{'){
		$progress = json_decode($q->progress, true);
		if(!is_array($progress)){
			$progress = false;
		}
	}

	// try to start the job
	if(!isset($curl)){
		$curl = curl_init();
		curl_setopt($curl, CURLOPT_POST, 1);
		curl_setopt($curl, CURLOPT_HTTPHEADER, array("Content-Type: application/x-www-form-urlencoded; charset=UTF-8"));
		curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($curl, CURLOPT_CONNECTTIMEOUT, 4);
		curl_setopt($curl, CURLOPT_TIMEOUT, 10);
	}
	$url = "http://".$servers[$min_id].$backend_uri;
	curl_setopt($curl, CURLOPT_URL, $url);
	$post = array();
	$post["a1"] = $q->auth->mapillary_client_id;
	$post["a2"] = $q->auth->mapillary_access_token;
	$post["a3"] = $q->subject;
	$post["a4"] = $q->auth->openstreetcam_token;
	$post["a5"] = $q->task_id;
	if($progress !== false && isset($progress["osc_sequence_id"]) && $progress["osc_sequence_id"] > 0){
		$post["a6"] = $progress["osc_sequence_id"];
		if(isset($progress["images_uploaded"]) && $progress["images_uploaded"] > 0){
			$post["a7"] = strval($progress["images_uploaded"]);
		}
	}
	ksort($post);
	$post["sign"] = hash("sha256", serialize($post).$backend_key);
	curl_setopt($curl, CURLOPT_POSTFIELDS, http_build_query($post));
	$response = curl_exec($curl);
	$http_code = curl_getinfo($curl, CURLINFO_HTTP_CODE);
	$errstr = "";
	if(!is_string($response)){
		$errstr = "Failed to contact server {$min_id}: ".curl_error($curl);
	}else if($http_code != 200){
		$errstr = "Server {$min_id} returned error {$http_code}";
	}else if($response != "OK"){
		$errstr = "Server {$min_id} returned: {$response}";
	}
	if($errstr === ""){
		echo "Job {$q->task_id} started on server {$min_id}";
		if(isset($post["a7"])){
			echo " (cont {$post['a7']})";
		}
		echo "\r\n";
		mysql_query("update mp2osc_jobs set started=UNIX_TIMESTAMP(), server=".intval($min_id)." where task_id='".mysql_real_escape_string($q->task_id)."' and task='mp2osc'") or die(mysql_error());
		$jobs_running_server[$min_id]++;
		return true;
	}else{
		echo "{$errstr}\r\n";
		$errstr.=", retrying in 1 minute";
		if($progress === false){
			mysql_query("update mp2osc_jobs set progress='".mysql_real_escape_string($errstr)."' where task_id='".mysql_real_escape_string($q->task_id)."' and task='mp2osc'") or die(mysql_error());
		}
		return false;
	}
}

$auth = array();
$jobs = array();
$jobs_running_total = 0;
$jobs_pending_total = 0;
$jobs_running_user = array();
$jobs_pending_user = array();
$jobs_running_server = array();

foreach($servers as $server_id => $ip){
	//echo "{$server_id} - ".file_get_contents("http://{$ip}/");
	$jobs_running_server[$server_id] = 0;
}

$qs = "select * from mp2osc_jobs where finished=0 and success=0 and task='mp2osc'"; // and length(subject)<32

if(!empty($argv[1])){
	$qs.=" and task_id='".mysql_real_escape_string($argv[1])."'";
}

$qr = mysql_query($qs) or die(mysql_error());
while($q = mysql_fetch_object($qr)){
	// load sequence details
	$sqr = mysql_query("select * from mapillary_sequence where sequence_key='".mysql_real_escape_string($q->subject)."'") or die(mysql_error());
	if(!($sq = mysql_fetch_object($sqr))){
		echo "Can't find sequence '{$q->subject}'\r\n";
		continue;
	}
	$q->sequence = $sq;
	// load credentials
	if(!isset($auth[$q->mapillary_userid])){
		$sqr = mysql_query("select * from mp2osc_auth where mapillary_userid='".mysql_real_escape_string($q->mapillary_userid)."'") or die(mysql_error());
		if(!($sq = mysql_fetch_object($sqr))){
			echo "Can't find auth '{$q->mapillary_userid}'\r\n";
			continue;
		}
		$q->auth = $sq;
	}
	// count stats
	if(!isset($jobs_pending_user[$q->mapillary_userid])){
		$jobs_pending_user[$q->mapillary_userid] = 0;
		$jobs_running_user[$q->mapillary_userid] = 0;
	}
	if($q->started == 0){
		$jobs_pending_total++;
		$jobs_pending_user[$q->mapillary_userid]++;
		// store pending job
		$jobs[$q->mapillary_userid][$q->task_id] = $q;
	}else{
		$jobs_running_total++;
		$jobs_running_user[$q->mapillary_userid]++;
		if(isset($jobs_running_server[$q->server])){
			$jobs_running_server[$q->server]++;
		}
	}
}

if($jobs_pending_total == 0){
	die("No jobs pending\r\n");
}

echo "Jobs in queue: {$jobs_pending_total}\r\n";

// sort each user's job lost by captured time, starting from oldest
function job_sort($a, $b){
	$a = strtotime($a->sequence->captured_at);
	$b = strtotime($b->sequence->captured_at);
	if ($a == $b) {
		return 0;
	}
	return ($a < $b) ? -1 : 1;
}
foreach($jobs as $user_id => $v){
	uasort($jobs[$user_id], "job_sort");
}

if($jobs_running_total >= $max_workers_total){
	// run only one job per user
	//$max_workers_per_user = max(1, intval(round($max_workers_total/count($jobs))));
	$max_workers_per_user = 1;
	echo "max_workers_per_user={$max_workers_per_user}\r\n";
}

foreach($jobs as $user_id => $v){
	if($jobs_running_user[$user_id] >= $max_workers_per_user){
		continue;
	}
	foreach($v as $task_id => $v){
		// start one job per user at time
		start_job($v);
		break;
	}
}

?>