function g(id){return document.getElementById(id);}

req = new Array();
function createRequestObject(method, url) {
	if (typeof XMLHttpRequest === 'undefined') {
		XMLHttpRequest = function() {
			try { return new ActiveXObject("Msxml2.XMLHTTP.6.0"); }
				catch(e) {}
			try { return new ActiveXObject("Msxml2.XMLHTTP.3.0"); }
				catch(e) {}
			try { return new ActiveXObject("Msxml2.XMLHTTP"); }
				catch(e) {}
			try { return new ActiveXObject("Microsoft.XMLHTTP"); }
				catch(e) {}
			alert("This browser does not support XMLHttpRequest.");
		};
	}
	var tmp=new XMLHttpRequest();
	tmp.open(method, url);
	if(method=="POST"){
		tmp.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
	}
	return tmp;
}

if(typeof document.hidden !== "undefined"){
	visibility_key = "hidden";
	visibilityChange = "visibilitychange";
}else if(typeof document.msHidden !== "undefined"){
	visibility_key = "msHidden";
	visibilityChange = "msvisibilitychange";
}else if(typeof document.webkitHidden !== "undefined"){
	visibility_key = "webkitHidden";
	visibilityChange = "webkitvisibilitychange";
}

page_visible = true;
function handleVisibilityChange(){
	if(document[visibility_key]){
		page_visible = false;
	}else{
		page_visible = true;
		jobs_list();
	}
}

function install_visibility_callback(){
	if(typeof(document.addEventListener) != "undefined" && typeof(visibilityChange) != "undefined"){
		document.addEventListener(visibilityChange, handleVisibilityChange, false);
	}
}

function timetodate(ts){
	if(ts <= 0){
		return "-";
	}
	var cur_date = new Date();
	var dateObject = new Date(ts*1000);
	if(dateObject.getFullYear() == cur_date.getFullYear()){
		return dateObject.toLocaleString([], {month: 'short', day: 'numeric', hour: '2-digit', minute:'2-digit'});
	}else{
		return dateObject.toLocaleString([], {year: 'numeric', month: 'short', day: 'numeric', hour: '2-digit', minute:'2-digit'});
	}
}

function time(){
	return new Date()/1000;
}

function htmlspecialchars(text){
	if(typeof(text) == "undefined"){
		return "";
	}
	return text.replace(/&/g, "&amp;").replace(/</g, "&lt;").replace(/>/g, "&gt;").replace(/"/g, "&quot;").replace(/'/g, "&#039;");
}

function hl_sequence_list(sequence_list_data, jobs_list_data){
	for(k in jobs_list_data){
		var v = jobs_list_data[k];
		if(v.task == "mp2osc"){
			var row = g("lblm_"+v.subject);
			if(!row){
				continue;
			}
			var status = "";
			if(v.started < 1){
				status = "queued";
			}else if(v.finished < 1){
				status = "working";
			}else{
				status = (v.success ? "finished" : "error");
			}
			row.className = status;
		}
	}
	for(k in sequence_list_data.osc){
		var v = sequence_list_data.osc[k];
		if(v.platform_name=="photosync"){
			var row = g("lblm_"+v.platform_version);
			if(row){
				row.className = "sync";
			}
			row = g("lblc_"+v.sequence_id);
			if(row){
				row.className = "sync";
			}
		}
	}
	for(k in sequence_list_data.mapillary){
		var v = sequence_list_data.mapillary[k];
		if(v.images_transferred > 0){
			var row = g("lblm_"+v.sequence_key);
			if(row){
				row.className = "sync";
			}
			row = g("lblc_"+v.sequence_key.substring(0,25));
			if(row){
				row.className = "sync";
			}
		}
	}
}

function render_jobs_list(data){
	buf="<table class=task_list cellpadding=0 cellspacing=0>";
	buf+= "<tr><th>Job ID</th><th>Task</th><th>Subject</th><th>Added</th><th>Started</th><th>Finished</th><th>Status</th><th>Details</th><th>Action</th></tr>";
	if(data.length == 0){
		buf+= "<tr><td colspan=9 align=center><i>No jobs yet</i></td></tr>";
	}
	var pending_count = 0;
	var running_count = 0;
	for(k in data){
		var v = data[k];
		var task = v.task;
		if(v.task == "read_mapillary"){
			task = "Read&nbsp;sequence&nbsp;list<br>(Mapillary)";
		}else if(v.task == "read_osc"){
			task = "Read&nbsp;sequence&nbsp;list<br>(OpenStreetCam)";
		}else if(v.task == "mp2osc"){
			task = "Copy&nbsp;sequence&nbsp;to<br>OpenStreetCam";
		}else if(v.task == "osc2mp"){
			task = "Copy&nbsp;sequence&nbsp;to<br>Mapillary";
		}
		var status = "";
		if(v.started < 1){
			status = "queued";
			if(v.task == "mp2osc" || v.task == "osc2mp"){
				pending_count++;
			}
		}else if(v.finished < 1){
			status = "working";
			if(v.task == "mp2osc" || v.task == "osc2mp"){
				running_count++;
			}
		}else{
			status = (v.success ? "finished" : "error");
		}
		var progress_str = v.progress;
		if(v.progress !== "" && (v.task == "read_mapillary" || v.task == "read_osc")){
			var progress = eval('('+v.progress+')');
			if(typeof(progress) == "object"){
				progress_str = "";
				if(typeof(progress.sequences_found) != "undefined"){
					progress_str += "Sequences&nbsp;found:&nbsp;"+progress.sequences_found+"<br>Images&nbsp;found:&nbsp;"+progress.images_found;
				}
				if(typeof(progress.errstr) != "undefined" && progress.errstr != ""){
					progress_str += ", Error: "+progress.errstr;
				}
				if(progress_str == ""){
					progress_str = v.progress;
				}
			}
		}else if(v.progress !== "" && (v.task == "mp2osc" || v.task == "osc2mp")){
			var progress = eval('('+v.progress+')');
			if(typeof(progress) == "object"){
				var lines = new Array();
				if(typeof(progress.images_discovered) != "undefined"){
					lines.push("Images&nbsp;discovered:&nbsp;"+progress.images_discovered);
				}
				if(typeof(progress.images_downloaded) != "undefined"){
					var tmp = "Images&nbsp;downloaded:&nbsp;"+progress.images_downloaded;
					if(typeof(progress.dw_speed) != "undefined"){
						tmp+=" ("+(progress.dw_speed/1024/1024).toFixed(1)+"MB/s)";
					}
					lines.push(tmp);
				}
				if(typeof(progress.images_uploaded) != "undefined"){
					var tmp = "Images&nbsp;uploaded:&nbsp;"+progress.images_uploaded;
					if(typeof(progress.ul_speed) != "undefined"){
						tmp+=" ("+(progress.ul_speed/1024/1024).toFixed(1)+"MB/s)";
					}
					lines.push(tmp);
				}
				if(typeof(progress.errstr) != "undefined" && progress.errstr != ""){
					lines.push("Error: "+progress.errstr);
				}
				progress_str = lines.join("<br>");
				if(progress_str == ""){
					progress_str = v.progress;
				}
			}
		}
		var action_str = "&nbsp;";
		if(v.task == "mp2osc" || v.task == "osc2mp"){
			if(v.started < 1){
				action_str = "<a href=\"javascript:cancel_job('"+v.task_id+"', '"+v.subject+"');void(0)\">cancel</a>";
			}else{
				action_str = "<a href=\"log.php?job="+v.task_id+"\" target=\"_blank\">view log</a>";
			}
		}
		buf+="<tr id=j"+v.task_id+" class=\"status_"+status+"\">";
		buf+="<td>"+v.task_id+"</td>";
		buf+="<td>"+task+"</td>";
		buf+="<td>"+v.subject+"</td>";
		buf+="<td>"+timetodate(v.added)+"</td>";
		buf+="<td>"+timetodate(v.started)+"</td>";
		buf+="<td>"+timetodate(v.finished)+"</td>";
		buf+="<td>"+status+"</td>";
		buf+="<td>"+progress_str+"</td>";
		buf+="<td>"+action_str+"</td>";
		buf+="</tr>";

	}
	buf+="</table>";
	if(running_count == 0 && pending_count > 0){
		buf = "<div class=y style=\"margin-bottom:10px\">It may take a minute for a transfer job to start, please be patient</div>"+buf;
	}
	g("job_list_div").innerHTML = buf;

	hl_sequence_list(sequence_list_data, data);
}

function render_sequence_list(data){
	services = 0;

	var buf = "";
	if(data.mapillary.length < 1){
		if(time() - data.mapillary_sequence_updated > 1*60*60){
			buf = "<span class=rbg>Press the button below to download the sequence list</span>";
		}else{
			buf = "No sequences";
			services++;
		}
	}else{
		for(k in data.mapillary){
			var v = data.mapillary[k];
			buf += "<label id=\"lblm_"+htmlspecialchars(v.sequence_key)+"\"><input type=checkbox id=\"cbm_"+htmlspecialchars(v.sequence_key)+"\" value=\""+htmlspecialchars(v.sequence_key)+"\">"+timetodate(v.captured_at_ts)+" ("+v.images+" images)</label><br>";
		}
		services++;
	}
	g("mapillary_sequence_list").innerHTML = buf;

	buf = "";
	if(data.osc.length < 1){
		if(time() - data.osc_sequence_updated > 1*60*60){
			buf = "<span class=rbg>Press the button below to download the sequence list</span>";
		}else{
			buf = "No sequences";
			services++;
		}
	}else{
		for(k in data.osc){
			var v = data.osc[k];
			buf += "<label id=\"lblc_"+htmlspecialchars(v.sequence_id)+"\"><input type=checkbox id=\"cbo_"+htmlspecialchars(v.sequence_id)+"\" value=\""+htmlspecialchars(v.sequence_id)+"\">"+timetodate(v.date_added_ts)+" ("+v.images+" images)</label><br>";
		}
		services++;
	}
	g("osc_sequence_list").innerHTML = buf;

	g("transfer_mapillary_btn").disabled = (services < 2);

	hl_sequence_list(data, jobs_list_data);
}

last_select_all = new Array();
last_select_all["mapillary"] = false;
last_select_all["osc"] = false;
function select_checkboxes(service, new_only){
	if(service == "mapillary"){
		for(k in sequence_list_data.mapillary){
			var v = sequence_list_data.mapillary[k];
			var cb = g("cbm_"+v.sequence_key);
			if(!cb){
				continue;
			}
			if(new_only && !last_select_all[service] && v.images_transferred > 0){
				break;
			}
			cb.checked = !last_select_all[service];
		}
		last_select_all[service] = !last_select_all[service];
	}else if(service == "osc"){
		for(k in sequence_list_data.osc){
			var v = sequence_list_data.osc[k];
			var cb = g("cbo_"+v.sequence_id);
			if(!cb){
				continue;
			}
			cb.checked = !last_select_all[service];
		}
		last_select_all[service] = !last_select_all[service];
	}
}

function select_new(service){
	select_checkboxes(service, true);
}

function select_all(service){
	select_checkboxes(service, false);
}

prev_working_tasks = 0;
jobs_list_tmr = null;
prev_jobs_cs = "";
jobs_list_data = new Array();
function jobs_list(){
	var service = "jobs";
	req[service]=createRequestObject("GET", "backend.php?status&cs="+prev_jobs_cs+"&rand="+Math.random());
	req[service].onreadystatechange = function(){
		if(req[service].readyState==4){
			if(req[service].status==200 && (req[service].responseText.substring(0,1)=="{" || req[service].responseText=="NC")){
				if(jobs_list_tmr != null){
					clearTimeout(jobs_list_tmr);
					jobs_list_tmr = null;
				}
				if(req[service].responseText != "NC"){
					var data = eval('('+req[service].responseText+')');
					if(typeof(data) != "object"){
						alert("Error while loading jobs list");
						return;
					}
					var working_tasks = 0;
					for(k in data["jobs"]){
						var v = data["jobs"][k];
						if(v.finished < 1){
							working_tasks++;
						}
					}
					render_jobs_list(data["jobs"]);
					hl_sequence_list(data["jobs"]);
					if(working_tasks != prev_working_tasks){
						prev_working_tasks = working_tasks;
						sequence_list();
					}
					prev_jobs_cs = data["cs"];
					jobs_list_data = data["jobs"];
				}
				jobs_list_tmr = setTimeout("jobs_list()", page_visible ? (prev_working_tasks ? 1000 : 10000) : 60000);
			}else{
				alert("Error: "+req[service].responseText);
			}
		}
	};
	req[service].send(null);
}

prev_sequence_cs = "";
sequence_list_data = new Array();
function sequence_list(){
	var service = "sequences";
	req[service]=createRequestObject("GET", "backend.php?sequences&cs="+prev_sequence_cs+"&rand="+Math.random());
	req[service].onreadystatechange = function(){
		if(req[service].readyState==4){
			if(req[service].status==200 && (req[service].responseText.substring(0,1)=="{" || req[service].responseText=="NC")){
				if(req[service].responseText != "NC"){
					var data = eval('('+req[service].responseText+')');
					if(typeof(data) != "object"){
						alert("Error while loading jobs list");
						return;
					}
					render_sequence_list(data);
					prev_sequence_cs = data["cs"];
					sequence_list_data = data;
				}
			}else{
				alert("Error: "+req[service].responseText);
			}
		}
	};
	req[service].send(null);
}

function update_list(service){
	req[service]=createRequestObject("POST", "backend.php");
	req[service].onreadystatechange = function(){
		if(req[service].readyState==4){
			if(req[service].status==200 && req[service].responseText.substring(0,1)=="K"){
				setTimeout("jobs_list();", 100);
			}else if(req[service].status==200 && req[service].responseText.substring(0,2)=="E:"){
				var errcode = req[service].responseText.substring(2);
				if(errcode == "FINISHED"){
					alert("This task was recently complete, please wait 5 minutes before running again");
				}else if(errcode == "STARTING"){
					alert("This task was already put on queue");
				}else if(errcode == "WORKING"){
					alert("This task is already being processed");
				}else if(errcode == "FAILED"){
					alert("This task has failed for some reason, please wait 5 minutes before running again");
				}else{
					alert("Backend returned error: "+errcode);
				}
			}else{
				alert("Error: "+req[service].responseText);
			}
		}
	};
	req[service].send("read_"+service+"=1");
}

function transfer(service){
	var checked = new Array();
	for(k in sequence_list_data.mapillary){
		var v = sequence_list_data.mapillary[k];
		var cb = g("cbm_"+v.sequence_key);
		if(cb && cb.checked){
			checked.push(v.sequence_key);
		}
	}
	if(checked.length < 1){
		alert("Nothing selected!");
		return;
	}
	//if(!prompt(checked.length+" sequences will be transfered. Continue?")){
	//	return;
	//}
	req[service]=createRequestObject("POST", "backend.php");
	req[service].onreadystatechange = function(){
		if(req[service].readyState==4){
			if(req[service].status!=200 || req[service].responseText.substring(0,1)!="K"){
				alert("Error: "+req[service].responseText);
			}
			if(req[service].status==200){
				setTimeout("jobs_list();", 100);
			}
		}
	};
	req[service].send(service+"="+checked.join(","));
}

function cancel_job(service, subject){
	req[service]=createRequestObject("POST", "backend.php");
	req[service].onreadystatechange = function(){
		if(req[service].readyState==4){
			if(req[service].status==200 && req[service].responseText.substring(0,1)=="K"){
				var row = g("lblm_"+subject);
				if(row){
					row.className = "";
				}
				setTimeout("jobs_list();", 100);
			}else{
				alert("Error: "+req[service].responseText);
			}
		}
	};
	req[service].send("cancel="+service);
}

function page_loaded(){
	install_visibility_callback();
	sequence_list();
	jobs_list();
}
