<?

$settings = array(
	"osm" => array(
		"v" => 1,
		"conskey" => "rBWV8Ea****************************pb9tw",
		"conssec" => "rpmeZI******************************8T6S",
		"req_url" => "https://www.openstreetmap.org/oauth/request_token",
		"auth_url" => "https://www.openstreetmap.org/oauth/authorize",
		"acc_url" => "https://www.openstreetmap.org/oauth/access_token",
		"api_url" => "https://api.openstreetmap.org/api/0.6/",
		"callback_url" => "https://osm.svimik.com/photosync/oauth_callback.php?provider=osm",
	),
	"mapillary" => array(
		"v" => 2,
		"conskey" => "MLY|423**********297|9cf43***********************c713",  // MkJK*******************************************5MzBh // OWlkd*****************************************c4MjU3
		"conssec" => "MLY|423**********297|f1f89***********************d14f",
		"auth_url" => "https://www.mapillary.com/connect",
		"api_url" => "https://a.mapillary.com/v2/oauth/token",
		"permissions" => "private:upload public:upload user:email user:read private:read", // 
		"callback_url" => "https://osm.svimik.com/photosync/oauth_callback.php?provider=mapillary",
	),
);

if(!empty($_SESSION["mapillary_client_id"])){
	$settings["mapillary"]["conskey"] = $_SESSION["mapillary_client_id"];
}

function uuid(){
	list($ms, $s) = explode(" ", microtime());
	return dechex($s).str_pad(dechex(intval(round($ms*0xFFFFFFFF))), 8, '0', STR_PAD_LEFT).bin2hex(openssl_random_pseudo_bytes(2));
}

function oauth_percent_encode($str){
	$allowed = array('0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F','G','H','I','J','K','L','M','N','O','P','Q','R','S','T','U','V','W','X','Y','Z','a','b','c','d','e','f','g','h','i','j','k','l','m','n','o','p','q','r','s','t','u','v','w','x','y','z','-','.','_','~');
	$ret = "";
	$str = strval($str);
	$len = strlen($str);
	for($i=0; $i<$len; $i++){
		$c = $str[$i];
		if(in_array($c, $allowed, true)){
			$ret.=$c;
		}else{
			$ret.="%".strtoupper(bin2hex($c));
		}
	}
	return $ret;
}

function oauth_build_header($arr){
	foreach($arr as $k=>$v){
		$arr[$k] = oauth_percent_encode($k).'="'.oauth_percent_encode($v).'"';
	}
	return implode(", ", $arr);
}

function oauth_build_query($arr){
	foreach($arr as $k=>$v){
		$arr[$k] = oauth_percent_encode($k).'='.oauth_percent_encode($v);
	}
	return implode("&", $arr);
}

function oauth_headers($method, $url, $post, $conskey, $conssec, $token="", $tokensec="", $callback="", $verifier){
	$auth = array();
	$auth["oauth_consumer_key"] = $conskey;
	$auth["oauth_signature_method"] = "HMAC-SHA1";
	$auth["oauth_timestamp"] = time();
	$auth["oauth_nonce"] = uuid();
	if(is_string($token) && $token !== ""){
		$auth["oauth_token"] = $token;
	}
	if(is_string($callback) && $callback !== ""){
		$auth["oauth_callback"] = $callback;
	}
	if(is_string($verifier) && $verifier !== ""){
		$auth["oauth_verifier"] = $verifier;
	}
	//$auth["oauth_version"] = "1.0";
	$oauth_header = oauth_build_header($auth);
	if(is_array($post)){
		foreach($post as $k=>$v){
			$auth[$k] = $v;
		}
	}
	ksort($auth);
	$sig = oauth_percent_encode(base64_encode(hash_hmac("sha1", "{$method}&".urlencode($url)."&".oauth_percent_encode(oauth_build_query($auth)), $conssec."&".$tokensec, true)));
	$headers = array();
	$headers[]="Authorization: OAuth {$oauth_header}, oauth_signature=\"{$sig}\"";
	return $headers;
}

function oauth_curl_exec($ch, $method, $url, $post, $scope, $token="", $tokensec="", $callback="", $verifier=""){
	global $settings;
	if(!isset($settings[$scope])){
		die("Unknown scope {$scope}");
	}
	$headers = oauth_headers($method, $url, $post, $settings[$scope]["conskey"], $settings[$scope]["conssec"], $token, $tokensec, $callback, $verifier);
	curl_setopt($ch, CURLOPT_POST, ($method === "POST") ? 1 : 0);
	curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
	if($method === "POST"){
		curl_setopt($ch, CURLOPT_POSTFIELDS, (is_array($post) && count($post) > 0) ? http_build_query($post) : "");
	}
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
	curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 10);
	curl_setopt($ch, CURLOPT_TIMEOUT, 20);
	curl_setopt($ch, CURLOPT_URL, $url);
	//curl_setopt($ch, CURLOPT_HEADER, 1);
	//curl_setopt($ch, CURLINFO_HEADER_OUT, 1);
	$ret = curl_exec($ch);
	//echo curl_getinfo($ch, CURLINFO_HEADER_OUT);
	//die($ret);
	return $ret;
}

function oauth_request_token($ch, $scope, &$errstr){
	global $settings;
	if(!isset($settings[$scope])){
		die("Unknown scope {$scope}");
	}
	$callback = (isset($settings[$scope]["callback_url"])) ? $settings[$scope]["callback_url"] : "";
	$response = oauth_curl_exec($ch, "POST", $settings[$scope]["req_url"], false, $scope, "", "", $callback);
	$http_code = curl_getinfo($ch, CURLINFO_HTTP_CODE);
	if(!is_string($response)){
		$errstr = "OAuth request_token error: failed to contact {$scope} server";
		return false;
	}else if($http_code != 200){
		$errstr = "OAuth request_token error: {$scope} server returned error {$http_code}";
		return false;
	}else if(strpos($response, "oauth_token_secret") === false){
		$errstr = "OAuth request_token error: invalid response from {$scope} server";
		return false;
	}
	parse_str($response, $ret);
	if(!is_array($ret) || !isset($ret["oauth_token"]) || !isset($ret["oauth_token_secret"])){
		$errstr = "OAuth request_token error: couldn't parse response from {$scope} server";
		return false;
	}
	return $ret;
}

function oauth_access_token($ch, $scope, $token, $tokensec, $verifier, &$errstr){
	global $settings;
	if(!isset($settings[$scope])){
		die("Unknown scope {$scope}");
	}
	$response = oauth_curl_exec($ch, "POST", $settings[$scope]["acc_url"], false, $scope, $token, $tokensec, "", $verifier);
	$http_code = curl_getinfo($ch, CURLINFO_HTTP_CODE);
	if(!is_string($response)){
		$errstr = "OAuth access_token error: failed to contact {$scope} server";
		return false;
	}else if($http_code != 200){
		$errstr = "OAuth access_token error: {$scope} server returned error {$http_code}";
		return false;
	}else if(strpos($response, "oauth_token_secret") === false){
		$errstr = "OAuth access_token error: invalid response from {$scope} server";
		return false;
	}
	parse_str($response, $ret);
	if(!is_array($ret) || !isset($ret["oauth_token"]) || !isset($ret["oauth_token_secret"])){
		$errstr = "OAuth access_token error: couldn't parse response from {$scope} server";
		return false;
	}
	return $ret;
}

function openstreetcam_auth($ch, $token, $tokensec, &$errstr){
	$post = array();
	$post["request_token"] = $token;
	$post["secret_token"] = $tokensec;
	$url = "https://openstreetcam.org/auth/openstreetmap/client_auth";
	curl_setopt($ch, CURLOPT_POST, 1);
	curl_setopt($ch, CURLOPT_HTTPHEADER, array("Content-Type: application/x-www-form-urlencoded; charset=UTF-8"));
	curl_setopt($ch, CURLOPT_POSTFIELDS, http_build_query($post));
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
	curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 10);
	curl_setopt($ch, CURLOPT_TIMEOUT, 20);
	curl_setopt($ch, CURLOPT_URL, $url);
	curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
	$response = curl_exec($ch);
	//echo "<pre>";echo curl_getinfo($ch, CURLINFO_HEADER_OUT);
	//echo "\r\n".http_build_query($post)."\r\n";
	//die($response);
	$http_code = curl_getinfo($ch, CURLINFO_HTTP_CODE);
	if(!is_string($response)){
		$errstr = "Error: failed to contact OpenStreetCam server";
		return false;
	}else if($http_code != 200){
		$errstr = "Error: OpenStreetCam server returned error {$http_code}";
		return false;
	}
	$data = json_decode($response, true);
	if(!is_array($data) || !isset($data["status"]) || !isset($data["osv"])){
		print_r($data);
		$errstr = "Error: invalid response from OpenStreetCam server";
		return false;
	}
	return $data;
}

function read_osm_profile($ch, $token, $tokensec, &$errstr){
	$scope = "osm";
	global $settings;
	if(!isset($settings[$scope])){
		die("Unknown scope {$scope}");
	}
	$response = oauth_curl_exec($ch, "GET", $settings[$scope]["api_url"]."user/details", false, $scope, $token, $tokensec);
	$http_code = curl_getinfo($ch, CURLINFO_HTTP_CODE);
	if(!is_string($response)){
		$errstr = "Error reading user profile: failed to contact OpenStreetMap server";
		return false;
	}else if($http_code != 200){
		$errstr = "Error reading user profile: OpenStreetMap server returned error {$http_code}";
		return false;
	}else if(strpos($response, "display_name") === false){
		$errstr = "Error reading user profile: invalid response from OpenStreetMap server";
		return false;
	}
	$xml = simplexml_load_string($response);
	if($xml === false || !isset($xml->user) || !isset($xml->user["id"]) || !isset($xml->user["display_name"])){
		$errstr = "Error reading user profile: invalid xml response from OpenStreetMap server";
		return false;
	}
	return $xml;
}

function read_mapillary_profile($ch, $token, &$errstr){
	$scope = "mapillary";
	global $settings;
	if(!isset($settings[$scope])){
		die("Unknown scope {$scope}");
	}
	$url = "https://a.mapillary.com/v3/me?client_id=".urlencode($settings[$scope]["conskey"])."&token=".urlencode($token);
	//echo "{$url}<br>";
	curl_setopt($ch, CURLOPT_POST, 0);
	curl_setopt($ch, CURLOPT_HTTPHEADER, array());
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
	curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 10);
	curl_setopt($ch, CURLOPT_TIMEOUT, 20);
	curl_setopt($ch, CURLOPT_URL, $url);
	//curl_setopt($ch, CURLOPT_HEADER, 1);
	//curl_setopt($ch, CURLINFO_HEADER_OUT, 1);
	$response = curl_exec($ch);
	//echo curl_getinfo($ch, CURLINFO_HEADER_OUT);
	//die($ret);
	$http_code = curl_getinfo($ch, CURLINFO_HTTP_CODE);
	if(!is_string($response)){
		$errstr = "Error reading user profile: failed to contact Mapillary server";
		return false;
	}else if($http_code != 200){
		$errstr = "Error reading user profile: Mapillary server returned error {$http_code}";
		return false;
	}
	$data = json_decode($response, true);
	if(!is_array($data) || !isset($data["email"]) || !isset($data["username"])){
		$errstr = "Error reading user profile: invalid response from Mapillary server";
		return false;
	}
	return $data;
}

?>