<?

require("mysql.php");

if(count($argv) < 5){
	die("Usage: task_id client_id token userid");
}

$task_id = $argv[1];
$client_id = $argv[2];
$mapillary_access_token = $argv[3];
$mapillary_userid = $argv[4];

$limit = 10000;
/*$qr = mysql_query("select count(*) as cnt from mapillary_sequence where user_key='".mysql_real_escape_string($mapillary_userid)."' and images_transferred>0") or die(mysql_error());
if(mysql_fetch_object($qr)->cnt > 0){
	$limit = 1000;
}
if($task_id === "0"){
	$limit = 5000;
}*/
echo "limit={$limit}\r\n";

function progress($progress, $is_finished=false, $is_success=0){
	$backend = "http://osm.svimik.com/photosync/workers_backend.php?task=read_mapillary";
	global $ch_progress, $progress_prev, $task_id;
	if(strlen($task_id) < 2){
		return;
	}
	if(isset($progress_prev) && microtime(true) - $progress_prev < 1.0 && $is_finished === false){
		return;
	}
	if(!isset($ch_progress)){
		$ch_progress = curl_init();
		curl_setopt($ch_progress, CURLOPT_POST, 1);
		curl_setopt($ch_progress, CURLOPT_HTTPHEADER, array("Content-Type: application/x-www-form-urlencoded; charset=UTF-8"));
		curl_setopt($ch_progress, CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($ch_progress, CURLOPT_CONNECTTIMEOUT, 4);
		curl_setopt($ch_progress, CURLOPT_TIMEOUT, 6);
		curl_setopt($ch_progress, CURLOPT_URL, $backend);
	}
	$post = array();
	$post["task_id"] = $task_id;
	$post["progress"] = json_encode($progress);
	if($is_finished){
		$post["finished"] = 1;
		$post["success"] = ($is_success?1:0);
	}
	curl_setopt($ch_progress, CURLOPT_POSTFIELDS, http_build_query($post));
	$ret = curl_exec($ch_progress);
	echo "Reporting status: ".($ret == "OK" ? "OK" : "error")."\r\n";
	$progress_prev = time();
}

progress(array("status"=>"starting"));

$ch = curl_init();
curl_setopt($ch, CURLOPT_HTTPHEADER, array("Authorization: Bearer {$mapillary_access_token}"));
curl_setopt($ch, CURLOPT_HEADER, 1);
curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 30);
curl_setopt($ch, CURLOPT_TIMEOUT, 120);

$url = "https://a.mapillary.com/v3/sequences?client_id={$client_id}&userkeys={$mapillary_userid}&per_page=50";
$errstr = false;
$sequences_found = 0;
$images_found = 0;
while($url !== false){
	echo "{$url}\r\n";
	$attempts = 4;
	$success = false;
	while(1){
		curl_setopt($ch, CURLOPT_URL, $url);
		$response = curl_exec($ch);
		$http_code = curl_getinfo($ch, CURLINFO_HTTP_CODE);
		if(!is_string($response)){
			if($attempts > 0){
				echo "Failed to contact Mapillary server: ".curl_error($ch).", retrying...\r\n";
				$attempts--;
				sleep(3);
				continue;
			}else{
				$errstr = "Failed to contact Mapillary server: ".curl_error($ch);
				break;
			}
		}else if($http_code != 200){
			if($attempts > 0){
				echo "Mapillary server returned error {$http_code}, retrying...\r\n";
				$attempts--;
				sleep(3);
				continue;
			}else{
				$errstr = "Mapillary server returned error {$http_code}";
				break;
			}
		}
		$success = true;
		break;
	}
	if(!$success){
		break; // all attempts failed
	}
	list($headers, $response) = explode("\r\n\r\n", $response, 2);
	$url = false;
	if(preg_match("/<([^>]+)>; rel=\"next\"/", $headers, $m)){
		$url = $m[1];
	}
	$data = json_decode($response, true);
	if(!is_array($data) || !isset($data["features"]) || !is_array($data["features"])){
		$errstr = "Invalid response from Mapillary server";
		break;
	}
	if(count($data["features"]) == 0){
		break;
	}

	$time = time();
	foreach($data["features"] as $v){
		if(!isset($v["properties"]["key"])){
			continue;
		}
		$sequence_key = $v["properties"]["key"];
		$set = array();
		$set["user_key"] = $v["properties"]["user_key"];
		$set["captured_at"] = $v["properties"]["captured_at"];
		$set["created_at"] = $v["properties"]["created_at"];
		$set["camera_make"] = $v["properties"]["camera_make"];
		$set["pano"] = $v["properties"]["pano"];
		$set["images"] = count($v["properties"]["coordinateProperties"]["image_keys"]);
		$set["updated"] = $time;
		mysql_query("insert into mapillary_sequence set sequence_key='".mysql_real_escape_string($sequence_key)."',".mysql_array_to_set($set)." on duplicate key update ".mysql_array_to_set($set)) or die(mysql_error());
		$image_keys = array();
		foreach($v["properties"]["coordinateProperties"]["image_keys"] as $id=>$image_key){
			$set = array();
			$set["sequence_key"] = $sequence_key;
			$set["sequence_sort"] = $id;
			$set["lon"] = $v["geometry"]["coordinates"][$id][0];
			$set["lat"] = $v["geometry"]["coordinates"][$id][1];
			$set["heading"] = $v["properties"]["coordinateProperties"]["cas"][$id];
			//mysql_query("insert into mapillary_image set image_key='".mysql_real_escape_string($image_key)."',".mysql_array_to_set($set)." on duplicate key update ".mysql_array_to_set($set)) or die(mysql_error());
			$image_keys[]="'".mysql_real_escape_string($image_key)."'";
			$images_found++;
		}
		//mysql_query("delete from mapillary_image where sequence_key='".mysql_real_escape_string($sequence_key)."' and image_key NOT IN(".implode(",", $image_keys).")") or die(mysql_error());
		$sequences_found++;
	}
	if($sequences_found >= $limit){
		break;
	}
	if($url !== false){
		progress(array("status"=>"working", "sequences_found"=>$sequences_found, "images_found"=>$images_found));
	}
}

if($errstr !== false){
	echo "ERROR: {$errstr}\r\n";
	progress(array("status"=>"error", "errstr"=>$errstr, "sequences_found"=>$sequences_found, "images_found"=>$images_found), true, 0);
}else{
	echo "seq:{$sequences_found},img:{$images_found}\r\n";
	progress(array("status"=>"finished", "sequences_found"=>$sequences_found, "images_found"=>$images_found), true, 1);
}

?>