<?

require("mysql.php");

if(count($argv) < 4){
	die("Usage: task_id token username");
}

$task_id = $argv[1];
$osc_access_token = $argv[2];
$osc_username = $argv[3];

$limit = 10000;

function progress($progress, $is_finished=false, $is_success=0){
	$backend = "http://osm.svimik.com/photosync/workers_backend.php?task=read_osc";
	global $ch_progress, $progress_prev, $task_id;
	if(strlen($task_id) < 2){
		return;
	}
	//if(isset($progress_prev) && microtime(true) - $progress_prev < 1.0 && $is_finished === false){
	//	return;
	//}
	if(!isset($ch_progress)){
		$ch_progress = curl_init();
		curl_setopt($ch_progress, CURLOPT_POST, 1);
		curl_setopt($ch_progress, CURLOPT_HTTPHEADER, array("Content-Type: application/x-www-form-urlencoded; charset=UTF-8"));
		curl_setopt($ch_progress, CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($ch_progress, CURLOPT_CONNECTTIMEOUT, 4);
		curl_setopt($ch_progress, CURLOPT_TIMEOUT, 5);
		curl_setopt($ch_progress, CURLOPT_URL, $backend);
	}
	$post = array();
	$post["task_id"] = $task_id;
	$post["progress"] = json_encode($progress);
	if($is_finished){
		$post["finished"] = 1;
		$post["success"] = ($is_success?1:0);
	}
	curl_setopt($ch_progress, CURLOPT_POSTFIELDS, http_build_query($post));
	$ret = curl_exec($ch_progress);
	echo "Reporting status: ".($ret == "OK" ? "OK" : "error")."\r\n";
	$progress_prev = time();
}

progress(array("status"=>"starting"));

$ch = curl_init();
$post = array("userName"=>$osc_username, "access_token"=>$osc_access_token, "ipp"=>100); // , "returnTrack"=>1
curl_setopt($ch, CURLOPT_POST, 1);
curl_setopt($ch, CURLOPT_HTTPHEADER, array("Content-Type: application/x-www-form-urlencoded; charset=UTF-8"));
curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 30);
curl_setopt($ch, CURLOPT_TIMEOUT, 120);
curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);

$url = "https://openstreetcam.org/1.0/list/";
$errstr = false;
$sequences_found = 0;
$images_found = 0;
$total_items = 0;
$page = 1;
$sequence_ids = array();
while($url !== false){
	$post["page"] = $page++;
	echo "Page: {$post['page']}\r\n";
	$attempts = 4;
	$success = false;
	while(1){
		curl_setopt($ch, CURLOPT_URL, $url);
		curl_setopt($ch, CURLOPT_POSTFIELDS, http_build_query($post));
		$response = curl_exec($ch);
		$http_code = curl_getinfo($ch, CURLINFO_HTTP_CODE);
		if(!is_string($response)){
			if($attempts > 0){
				echo "Failed to contact OpenStreetCam server: ".curl_error($ch).", retrying...\r\n";
				$attempts--;
				sleep(3);
				continue;
			}else{
				$errstr = "Failed to contact OpenStreetCam server: ".curl_error($ch);
				break;
			}
		}else if($http_code != 200){
			if($attempts > 0){
				echo "OpenStreetCam server returned error {$http_code}, retrying...\r\n";
				$attempts--;
				sleep(3);
				continue;
			}else{
				$errstr = "OpenStreetCam server returned error {$http_code}";
				break;
			}
		}
		$success = true;
		break;
	}
	if(!$success){
		break; // all attempts failed
	}
	$data = json_decode($response, true);
	if(!is_array($data) || !isset($data["status"]) || !isset($data["currentPageItems"])){
		$errstr = "Invalid response from OpenStreetCam server";
		break;
	}
	//print_r($data);die();
	if(count($data["currentPageItems"]) == 0){
		break;
	}
	if(isset($data["totalFilteredItems"]) && isset($data["totalFilteredItems"][0])){
		$total_items = intval($data["totalFilteredItems"][0]);
	}

	$time = time();
	foreach($data["currentPageItems"] as $v){
		if(!isset($v["id"])){
			continue;
		}
		$sequence_id = $v["id"];
		$set = array();
		$set["user_id"] = $v["user_id"];
		$set["date_added"] = $v["date_added"];
		$set["platform_name"] = $v["platform_name"];
		$set["platform_version"] = $v["platform_version"];
		$set["status"] = $v["image_processing_status"];
		$set["images"] = $v["photo_no"];
		$set["nw_lat"] = $v["nw_lat"];
		$set["nw_lon"] = $v["nw_lng"];
		$set["se_lat"] = $v["se_lat"];
		$set["se_lon"] = $v["se_lng"];
		$set["distance"] = $v["distance"];
		$set["thumb_name"] = $v["thumb_name"];
		$set["updated"] = $time;
		mysql_query("insert into openstreetcam_sequence set sequence_id='".mysql_real_escape_string($sequence_id)."',".mysql_array_to_set($set)." on duplicate key update ".mysql_array_to_set($set)) or die(mysql_error());
		$sequences_found++;
		$images_found += intval($v["photo_no"]);
		$sequence_ids[$sequence_id] = $v["photo_no"];
	}
	if($total_items > 0 && $sequences_found == $total_items){
		echo "DONE\r\n";
		break;
	}
	if($sequences_found >= $limit){
		break;
	}
	if($url !== false){
		progress(array("status"=>"working", "sequences_found"=>$sequences_found, "images_found"=>$images_found));
	}
}

if($errstr !== false){
	echo "ERROR: {$errstr}\r\n";
	progress(array("status"=>"error", "errstr"=>$errstr, "sequences_found"=>$sequences_found, "images_found"=>$images_found), true, 0);
}else{
	echo "seq:{$sequences_found},img:{$images_found}\r\n";
	progress(array("status"=>"finished", "sequences_found"=>$sequences_found, "images_found"=>$images_found), true, 1);
}
die();

// Optional: Download the image list
$images_found = 0;
foreach($sequence_ids as $sequence_id => $expected_count){
	$qr = mysql_query("select count(*) as cnt from openstreetcam_image where sequence_id='".mysql_real_escape_string($sequence_id)."'") or die(mysql_error());
	if(mysql_fetch_object($qr)->cnt >= $expected_count){
		continue;
	}

	// download the sequence details
	$url = "https://openstreetcam.org/details";
	curl_setopt($ch, CURLOPT_URL, $url);
	$post = array("id"=>$sequence_id, "access_token"=>$osc_access_token);
	curl_setopt($ch, CURLOPT_POSTFIELDS, http_build_query($post));
	$response = curl_exec($ch);
	$http_code = curl_getinfo($ch, CURLINFO_HTTP_CODE);
	if(!is_string($response)){
		$errstr = "Failed to contact OpenStreetCam server: ".curl_error($ch);
		break;
	}else if($http_code != 200){
		$errstr = "OpenStreetCam server returned error {$http_code}";
		break;
	}
	$sequence = json_decode($response, true);
	if(!is_array($sequence) || !isset($sequence["status"]) || !isset($sequence["osv"]) || !isset($sequence["osv"]["photos"])){
		$errstr = "Invalid response from OpenStreetCam server";
		break;
	}
	if(count($sequence["osv"]["photos"]) < 1){
		continue;
	}
	$image_keys = array();
	$images_found_seq = 0;
	foreach($sequence["osv"]["photos"] as $image){
		$set = array();
		$set["sequence_id"] = $image["sequence_id"];
		$set["sequence_sort"] = $image["sequence_index"];
		$set["lat"] = $image["lat"];
		$set["lon"] = $image["lng"];
		$set["heading"] = $image["heading"];
		$set["date_added"] = $image["date_added"];
		$set["timestamp"] = $image["timestamp"];
		$set["shot_date"] = (empty($image["shot_date"]) ? "" : $image["shot_date"]);
		$set["storage"] = $image["storage"];
		$set["path"] = $image["path"];
		$set["filename"] = $image["fileName"];
		$set["width"] = $image["width"];
		$set["height"] = $image["height"];
		mysql_query("insert into openstreetcam_image set image_id='".mysql_real_escape_string($image["id"])."',".mysql_array_to_set($set)." on duplicate key update ".mysql_array_to_set($set)) or die(mysql_error());
		$image_keys[]="'".mysql_real_escape_string($image["id"])."'";
		$images_found_seq++;
		$images_found++;
	}
	mysql_query("delete from openstreetcam_image where sequence_id='".mysql_real_escape_string($sequence_id)."' and image_id NOT IN(".implode(",", $image_keys).")") or die(mysql_error());
	echo "{$sequence_id}: {$images_found_seq} / {$expected_count}\r\n";
}

if($errstr !== false){
	echo "ERROR: {$errstr}\r\n";
}
echo "seq:{$sequences_found},img:{$images_found}\r\n";

?>